/* board-view-gtk.c generated by valac 0.56.17, the Vala compiler
 * generated from board-view-gtk.vala, do not modify */

/*
 * Copyright (C) 2018 Robert Roth
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>

#define BOARD_VIEW_GTK_MIN_TOGGLE_SIZE 48
#define BOARD_VIEW_size 5
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BOARD_VIEW (board_view_get_type ())
#define BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD_VIEW, BoardView))
#define IS_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD_VIEW))
#define BOARD_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_BOARD_VIEW, BoardViewIface))

typedef struct _BoardView BoardView;
typedef struct _BoardViewIface BoardViewIface;

#define TYPE_PUZZLE_GENERATOR (puzzle_generator_get_type ())
#define PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGenerator))
#define PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))
#define IS_PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE_GENERATOR))
#define IS_PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE_GENERATOR))
#define PUZZLE_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))

typedef struct _PuzzleGenerator PuzzleGenerator;
typedef struct _PuzzleGeneratorClass PuzzleGeneratorClass;

#define TYPE_BOARD_VIEW_GTK (board_view_gtk_get_type ())
#define BOARD_VIEW_GTK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD_VIEW_GTK, BoardViewGtk))
#define BOARD_VIEW_GTK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOARD_VIEW_GTK, BoardViewGtkClass))
#define IS_BOARD_VIEW_GTK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD_VIEW_GTK))
#define IS_BOARD_VIEW_GTK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOARD_VIEW_GTK))
#define BOARD_VIEW_GTK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOARD_VIEW_GTK, BoardViewGtkClass))

typedef struct _BoardViewGtk BoardViewGtk;
typedef struct _BoardViewGtkClass BoardViewGtkClass;
typedef struct _BoardViewGtkPrivate BoardViewGtkPrivate;
enum  {
	BOARD_VIEW_GTK_0_PROPERTY,
	BOARD_VIEW_GTK_NUM_PROPERTIES
};
static GParamSpec* board_view_gtk_properties[BOARD_VIEW_GTK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _BoardViewIface {
	GTypeInterface parent_iface;
	gint (*get_moves) (BoardView* self);
	PuzzleGenerator* (*get_puzzle_generator) (BoardView* self);
	void (*clear_level) (BoardView* self);
	void (*toggle_light) (BoardView* self, gint x, gint y, gboolean user_initiated);
	void (*increase_moves) (BoardView* self);
	gboolean (*is_light_active) (BoardView* self, gint x, gint y);
	GObject* (*get_light_at) (BoardView* self, gint x, gint y);
};

struct _BoardViewGtk {
	GtkGrid parent_instance;
	BoardViewGtkPrivate * priv;
};

struct _BoardViewGtkClass {
	GtkGridClass parent_class;
};

struct _BoardViewGtkPrivate {
	PuzzleGenerator* puzzle_generator;
	GtkToggleButton** lights;
	gint lights_length1;
	gint lights_length2;
	gint _moves;
};

static gint BoardViewGtk_private_offset;
static gpointer board_view_gtk_parent_class = NULL;
static BoardViewIface * board_view_gtk_board_view_parent_iface = NULL;

VALA_EXTERN GType puzzle_generator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PuzzleGenerator, g_object_unref)
VALA_EXTERN GType board_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BoardView, g_object_unref)
VALA_EXTERN GType board_view_gtk_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BoardViewGtk, g_object_unref)
static gint board_view_gtk_real_get_moves (BoardView* base);
static void board_view_gtk_real_toggle_light (BoardView* base,
                                       gint x,
                                       gint y,
                                       gboolean clicked);
VALA_EXTERN void board_view_handle_toggle (BoardView* self,
                               GObject* light);
static void _board_view_handle_toggle_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                          gpointer self);
static void board_view_gtk_real_clear_level (BoardView* base);
static PuzzleGenerator* board_view_gtk_real_get_puzzle_generator (BoardView* base);
static gboolean board_view_gtk_real_is_light_active (BoardView* base,
                                              gint x,
                                              gint y);
static GObject* board_view_gtk_real_get_light_at (BoardView* base,
                                           gint x,
                                           gint y);
static void board_view_gtk_real_increase_moves (BoardView* base);
VALA_EXTERN BoardViewGtk* board_view_gtk_new (void);
VALA_EXTERN BoardViewGtk* board_view_gtk_construct (GType object_type);
static GObject * board_view_gtk_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
VALA_EXTERN PuzzleGenerator* puzzle_generator_new (gint size);
VALA_EXTERN PuzzleGenerator* puzzle_generator_construct (GType object_type,
                                             gint size);
static void _board_view_gtk___lambda4_ (BoardViewGtk* self);
static void __board_view_gtk___lambda4__board_view_completed (BoardView* _sender,
                                                       gpointer self);
VALA_EXTERN gint board_view_get_moves (BoardView* self);
VALA_EXTERN void board_view_toggle_light (BoardView* self,
                              gint x,
                              gint y,
                              gboolean user_initiated);
VALA_EXTERN void board_view_clear_level (BoardView* self);
VALA_EXTERN PuzzleGenerator* board_view_get_puzzle_generator (BoardView* self);
VALA_EXTERN gboolean board_view_is_light_active (BoardView* self,
                                     gint x,
                                     gint y);
VALA_EXTERN GObject* board_view_get_light_at (BoardView* self,
                                  gint x,
                                  gint y);
VALA_EXTERN void board_view_increase_moves (BoardView* self);
static void board_view_gtk_finalize (GObject * obj);
static GType board_view_gtk_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
board_view_gtk_get_instance_private (BoardViewGtk* self)
{
	return G_STRUCT_MEMBER_P (self, BoardViewGtk_private_offset);
}

static gint
board_view_gtk_real_get_moves (BoardView* base)
{
	BoardViewGtk * self;
	gint result;
	self = (BoardViewGtk*) base;
	result = self->priv->_moves;
	return result;
}

static void
_board_view_handle_toggle_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                     gpointer self)
{
	board_view_handle_toggle ((BoardView*) self, _sender);
}

static void
board_view_gtk_real_toggle_light (BoardView* base,
                                  gint x,
                                  gint y,
                                  gboolean clicked)
{
	BoardViewGtk * self;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	self = (BoardViewGtk*) base;
	{
		guint8 i = 0U;
		i = (guint8) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					guint8 _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(((gint) i) < 5)) {
					break;
				}
				{
					guint8 j = 0U;
					j = (guint8) 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							GtkToggleButton** _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							GtkToggleButton* _tmp5_;
							guint _tmp6_;
							if (!_tmp2_) {
								guint8 _tmp3_;
								_tmp3_ = j;
								j = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(((gint) j) < 5)) {
								break;
							}
							_tmp4_ = self->priv->lights;
							_tmp4__length1 = self->priv->lights_length1;
							_tmp4__length2 = self->priv->lights_length2;
							_tmp5_ = _tmp4_[(i * _tmp4__length2) + j];
							g_signal_parse_name ("toggled", gtk_toggle_button_get_type (), &_tmp6_, NULL, FALSE);
							g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _board_view_handle_toggle_gtk_toggle_button_toggled, (BoardView*) self);
						}
					}
				}
			}
		}
	}
	if (x >= BOARD_VIEW_size) {
		_tmp9_ = TRUE;
	} else {
		_tmp9_ = y >= BOARD_VIEW_size;
	}
	if (_tmp9_) {
		_tmp8_ = TRUE;
	} else {
		_tmp8_ = x < 0;
	}
	if (_tmp8_) {
		_tmp7_ = TRUE;
	} else {
		_tmp7_ = y < 0;
	}
	if (_tmp7_) {
		return;
	}
	if ((((gint) x) + 1) < BOARD_VIEW_size) {
		GtkToggleButton** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		GtkToggleButton* _tmp11_;
		GtkToggleButton** _tmp12_;
		gint _tmp12__length1;
		gint _tmp12__length2;
		GtkToggleButton* _tmp13_;
		_tmp10_ = self->priv->lights;
		_tmp10__length1 = self->priv->lights_length1;
		_tmp10__length2 = self->priv->lights_length2;
		_tmp11_ = _tmp10_[((((gint) x) + 1) * _tmp10__length2) + ((gint) y)];
		_tmp12_ = self->priv->lights;
		_tmp12__length1 = self->priv->lights_length1;
		_tmp12__length2 = self->priv->lights_length2;
		_tmp13_ = _tmp12_[((((gint) x) + 1) * _tmp12__length2) + ((gint) y)];
		gtk_toggle_button_set_active (_tmp11_, !gtk_toggle_button_get_active (_tmp13_));
	}
	if ((((gint) x) - 1) >= 0) {
		GtkToggleButton** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		GtkToggleButton* _tmp15_;
		GtkToggleButton** _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		GtkToggleButton* _tmp17_;
		_tmp14_ = self->priv->lights;
		_tmp14__length1 = self->priv->lights_length1;
		_tmp14__length2 = self->priv->lights_length2;
		_tmp15_ = _tmp14_[((((gint) x) - 1) * _tmp14__length2) + ((gint) y)];
		_tmp16_ = self->priv->lights;
		_tmp16__length1 = self->priv->lights_length1;
		_tmp16__length2 = self->priv->lights_length2;
		_tmp17_ = _tmp16_[((((gint) x) - 1) * _tmp16__length2) + ((gint) y)];
		gtk_toggle_button_set_active (_tmp15_, !gtk_toggle_button_get_active (_tmp17_));
	}
	if ((((gint) y) + 1) < BOARD_VIEW_size) {
		GtkToggleButton** _tmp18_;
		gint _tmp18__length1;
		gint _tmp18__length2;
		GtkToggleButton* _tmp19_;
		GtkToggleButton** _tmp20_;
		gint _tmp20__length1;
		gint _tmp20__length2;
		GtkToggleButton* _tmp21_;
		_tmp18_ = self->priv->lights;
		_tmp18__length1 = self->priv->lights_length1;
		_tmp18__length2 = self->priv->lights_length2;
		_tmp19_ = _tmp18_[(((gint) x) * _tmp18__length2) + (((gint) y) + 1)];
		_tmp20_ = self->priv->lights;
		_tmp20__length1 = self->priv->lights_length1;
		_tmp20__length2 = self->priv->lights_length2;
		_tmp21_ = _tmp20_[(((gint) x) * _tmp20__length2) + (((gint) y) + 1)];
		gtk_toggle_button_set_active (_tmp19_, !gtk_toggle_button_get_active (_tmp21_));
	}
	if ((((gint) y) - 1) >= 0) {
		GtkToggleButton** _tmp22_;
		gint _tmp22__length1;
		gint _tmp22__length2;
		GtkToggleButton* _tmp23_;
		GtkToggleButton** _tmp24_;
		gint _tmp24__length1;
		gint _tmp24__length2;
		GtkToggleButton* _tmp25_;
		_tmp22_ = self->priv->lights;
		_tmp22__length1 = self->priv->lights_length1;
		_tmp22__length2 = self->priv->lights_length2;
		_tmp23_ = _tmp22_[(((gint) x) * _tmp22__length2) + (((gint) y) - 1)];
		_tmp24_ = self->priv->lights;
		_tmp24__length1 = self->priv->lights_length1;
		_tmp24__length2 = self->priv->lights_length2;
		_tmp25_ = _tmp24_[(((gint) x) * _tmp24__length2) + (((gint) y) - 1)];
		gtk_toggle_button_set_active (_tmp23_, !gtk_toggle_button_get_active (_tmp25_));
	}
	if (!clicked) {
		GtkToggleButton** _tmp26_;
		gint _tmp26__length1;
		gint _tmp26__length2;
		GtkToggleButton* _tmp27_;
		GtkToggleButton** _tmp28_;
		gint _tmp28__length1;
		gint _tmp28__length2;
		GtkToggleButton* _tmp29_;
		_tmp26_ = self->priv->lights;
		_tmp26__length1 = self->priv->lights_length1;
		_tmp26__length2 = self->priv->lights_length2;
		_tmp27_ = _tmp26_[(((gint) x) * _tmp26__length2) + ((gint) y)];
		_tmp28_ = self->priv->lights;
		_tmp28__length1 = self->priv->lights_length1;
		_tmp28__length2 = self->priv->lights_length2;
		_tmp29_ = _tmp28_[(((gint) x) * _tmp28__length2) + ((gint) y)];
		gtk_toggle_button_set_active (_tmp27_, !gtk_toggle_button_get_active (_tmp29_));
	}
	{
		guint8 i = 0U;
		i = (guint8) 0;
		{
			gboolean _tmp30_ = FALSE;
			_tmp30_ = TRUE;
			while (TRUE) {
				if (!_tmp30_) {
					guint8 _tmp31_;
					_tmp31_ = i;
					i = _tmp31_ + 1;
				}
				_tmp30_ = FALSE;
				if (!(((gint) i) < 5)) {
					break;
				}
				{
					guint8 j = 0U;
					j = (guint8) 0;
					{
						gboolean _tmp32_ = FALSE;
						_tmp32_ = TRUE;
						while (TRUE) {
							GtkToggleButton** _tmp34_;
							gint _tmp34__length1;
							gint _tmp34__length2;
							GtkToggleButton* _tmp35_;
							if (!_tmp32_) {
								guint8 _tmp33_;
								_tmp33_ = j;
								j = _tmp33_ + 1;
							}
							_tmp32_ = FALSE;
							if (!(((gint) j) < 5)) {
								break;
							}
							_tmp34_ = self->priv->lights;
							_tmp34__length1 = self->priv->lights_length1;
							_tmp34__length2 = self->priv->lights_length2;
							_tmp35_ = _tmp34_[(i * _tmp34__length2) + j];
							g_signal_connect_object (_tmp35_, "toggled", (GCallback) _board_view_handle_toggle_gtk_toggle_button_toggled, (BoardView*) self, 0);
						}
					}
				}
			}
		}
	}
}

static void
board_view_gtk_real_clear_level (BoardView* base)
{
	BoardViewGtk * self;
	self = (BoardViewGtk*) base;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(x < BOARD_VIEW_size)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							GtkToggleButton** _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							GtkToggleButton* _tmp5_;
							if (!_tmp2_) {
								gint _tmp3_;
								_tmp3_ = y;
								y = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(y < BOARD_VIEW_size)) {
								break;
							}
							_tmp4_ = self->priv->lights;
							_tmp4__length1 = self->priv->lights_length1;
							_tmp4__length2 = self->priv->lights_length2;
							_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
							gtk_toggle_button_set_active (_tmp5_, FALSE);
						}
					}
				}
			}
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static PuzzleGenerator*
board_view_gtk_real_get_puzzle_generator (BoardView* base)
{
	BoardViewGtk * self;
	PuzzleGenerator* _tmp0_;
	PuzzleGenerator* _tmp1_;
	PuzzleGenerator* result;
	self = (BoardViewGtk*) base;
	_tmp0_ = self->priv->puzzle_generator;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static gboolean
board_view_gtk_real_is_light_active (BoardView* base,
                                     gint x,
                                     gint y)
{
	BoardViewGtk * self;
	GtkToggleButton** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GtkToggleButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
	self = (BoardViewGtk*) base;
	_tmp0_ = self->priv->lights;
	_tmp0__length1 = self->priv->lights_length1;
	_tmp0__length2 = self->priv->lights_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = gtk_toggle_button_get_active (_tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp3_;
	return result;
}

static GObject*
board_view_gtk_real_get_light_at (BoardView* base,
                                  gint x,
                                  gint y)
{
	BoardViewGtk * self;
	GtkToggleButton** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GtkToggleButton* _tmp1_;
	GObject* _tmp2_;
	GObject* result;
	self = (BoardViewGtk*) base;
	_tmp0_ = self->priv->lights;
	_tmp0__length1 = self->priv->lights_length1;
	_tmp0__length2 = self->priv->lights_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = _g_object_ref0 ((GObject*) _tmp1_);
	result = _tmp2_;
	return result;
}

static void
board_view_gtk_real_increase_moves (BoardView* base)
{
	BoardViewGtk * self;
	self = (BoardViewGtk*) base;
	self->priv->_moves = self->priv->_moves + 1;
}

BoardViewGtk*
board_view_gtk_construct (GType object_type)
{
	BoardViewGtk * self = NULL;
	self = (BoardViewGtk*) g_object_new (object_type, NULL);
	return self;
}

BoardViewGtk*
board_view_gtk_new (void)
{
	return board_view_gtk_construct (TYPE_BOARD_VIEW_GTK);
}

static void
_board_view_gtk___lambda4_ (BoardViewGtk* self)
{
	gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
}

static void
__board_view_gtk___lambda4__board_view_completed (BoardView* _sender,
                                                  gpointer self)
{
	_board_view_gtk___lambda4_ ((BoardViewGtk*) self);
}

static GObject *
board_view_gtk_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BoardViewGtk * self;
	GtkStyleContext* _tmp0_;
	PuzzleGenerator* _tmp1_;
	GtkToggleButton** _tmp2_;
	parent_class = G_OBJECT_CLASS (board_view_gtk_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOARD_VIEW_GTK, BoardViewGtk);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "grid");
	gtk_grid_set_row_homogeneous ((GtkGrid*) self, TRUE);
	gtk_grid_set_column_homogeneous ((GtkGrid*) self, TRUE);
	gtk_widget_set_margin_start ((GtkWidget*) self, 2);
	gtk_widget_set_margin_end ((GtkWidget*) self, 2);
	gtk_widget_set_margin_top ((GtkWidget*) self, 2);
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 2);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 2);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 2);
	gtk_widget_set_size_request ((GtkWidget*) self, BOARD_VIEW_size * BOARD_VIEW_GTK_MIN_TOGGLE_SIZE, BOARD_VIEW_size * BOARD_VIEW_GTK_MIN_TOGGLE_SIZE);
	_tmp1_ = puzzle_generator_new (BOARD_VIEW_size);
	_g_object_unref0 (self->priv->puzzle_generator);
	self->priv->puzzle_generator = _tmp1_;
	_tmp2_ = g_new0 (GtkToggleButton*, (BOARD_VIEW_size * BOARD_VIEW_size) + 1);
	self->priv->lights = (_vala_array_free (self->priv->lights, self->priv->lights_length1 * self->priv->lights_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->lights = _tmp2_;
	self->priv->lights_length1 = BOARD_VIEW_size;
	self->priv->lights_length2 = BOARD_VIEW_size;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = x;
					x = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				if (!(x < BOARD_VIEW_size)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp5_ = FALSE;
						_tmp5_ = TRUE;
						while (TRUE) {
							GtkToggleButton** _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							GtkToggleButton* _tmp8_;
							GtkToggleButton** _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							GtkToggleButton* _tmp10_;
							GtkToggleButton** _tmp11_;
							gint _tmp11__length1;
							gint _tmp11__length2;
							GtkToggleButton* _tmp12_;
							if (!_tmp5_) {
								gint _tmp6_;
								_tmp6_ = y;
								y = _tmp6_ + 1;
							}
							_tmp5_ = FALSE;
							if (!(y < BOARD_VIEW_size)) {
								break;
							}
							_tmp7_ = self->priv->lights;
							_tmp7__length1 = self->priv->lights_length1;
							_tmp7__length2 = self->priv->lights_length2;
							_tmp8_ = (GtkToggleButton*) gtk_toggle_button_new ();
							g_object_ref_sink (_tmp8_);
							_g_object_unref0 (_tmp7_[(x * _tmp7__length2) + y]);
							_tmp7_[(x * _tmp7__length2) + y] = _tmp8_;
							_tmp9_ = self->priv->lights;
							_tmp9__length1 = self->priv->lights_length1;
							_tmp9__length2 = self->priv->lights_length2;
							_tmp10_ = _tmp9_[(x * _tmp9__length2) + y];
							g_signal_connect_object (_tmp10_, "toggled", (GCallback) _board_view_handle_toggle_gtk_toggle_button_toggled, (BoardView*) self, 0);
							_tmp11_ = self->priv->lights;
							_tmp11__length1 = self->priv->lights_length1;
							_tmp11__length2 = self->priv->lights_length2;
							_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
							gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp12_, x, y, 1, 1);
						}
					}
				}
			}
		}
	}
	self->priv->_moves = 0;
	g_signal_connect_object ((BoardView*) self, "completed", (GCallback) __board_view_gtk___lambda4__board_view_completed, self, 0);
	return obj;
}

static void
board_view_gtk_class_init (BoardViewGtkClass * klass,
                           gpointer klass_data)
{
	board_view_gtk_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BoardViewGtk_private_offset);
	G_OBJECT_CLASS (klass)->constructor = board_view_gtk_constructor;
	G_OBJECT_CLASS (klass)->finalize = board_view_gtk_finalize;
}

static void
board_view_gtk_board_view_interface_init (BoardViewIface * iface,
                                          gpointer iface_data)
{
	board_view_gtk_board_view_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_moves = (gint (*) (BoardView*)) board_view_gtk_real_get_moves;
	iface->toggle_light = (void (*) (BoardView*, gint, gint, gboolean)) board_view_gtk_real_toggle_light;
	iface->clear_level = (void (*) (BoardView*)) board_view_gtk_real_clear_level;
	iface->get_puzzle_generator = (PuzzleGenerator* (*) (BoardView*)) board_view_gtk_real_get_puzzle_generator;
	iface->is_light_active = (gboolean (*) (BoardView*, gint, gint)) board_view_gtk_real_is_light_active;
	iface->get_light_at = (GObject* (*) (BoardView*, gint, gint)) board_view_gtk_real_get_light_at;
	iface->increase_moves = (void (*) (BoardView*)) board_view_gtk_real_increase_moves;
}

static void
board_view_gtk_instance_init (BoardViewGtk * self,
                              gpointer klass)
{
	self->priv = board_view_gtk_get_instance_private (self);
	self->priv->_moves = 0;
}

static void
board_view_gtk_finalize (GObject * obj)
{
	BoardViewGtk * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOARD_VIEW_GTK, BoardViewGtk);
	_g_object_unref0 (self->priv->puzzle_generator);
	self->priv->lights = (_vala_array_free (self->priv->lights, self->priv->lights_length1 * self->priv->lights_length2, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (board_view_gtk_parent_class)->finalize (obj);
}

static GType
board_view_gtk_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BoardViewGtkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) board_view_gtk_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoardViewGtk), 0, (GInstanceInitFunc) board_view_gtk_instance_init, NULL };
	static const GInterfaceInfo board_view_info = { (GInterfaceInitFunc) board_view_gtk_board_view_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType board_view_gtk_type_id;
	board_view_gtk_type_id = g_type_register_static (gtk_grid_get_type (), "BoardViewGtk", &g_define_type_info, 0);
	g_type_add_interface_static (board_view_gtk_type_id, TYPE_BOARD_VIEW, &board_view_info);
	BoardViewGtk_private_offset = g_type_add_instance_private (board_view_gtk_type_id, sizeof (BoardViewGtkPrivate));
	return board_view_gtk_type_id;
}

GType
board_view_gtk_get_type (void)
{
	static volatile gsize board_view_gtk_type_id__once = 0;
	if (g_once_init_enter (&board_view_gtk_type_id__once)) {
		GType board_view_gtk_type_id;
		board_view_gtk_type_id = board_view_gtk_get_type_once ();
		g_once_init_leave (&board_view_gtk_type_id__once, board_view_gtk_type_id);
	}
	return board_view_gtk_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

